<template>
        <div class="app-layoutpanel HasPanelKanBan" v-loading="isLayoutLoadding" :style="{width: '100%', height: '100%',  overflow: 'auto'}">
        <template v-show="!isLayoutLoadding">
    <app-standard-container name="container1" :isMultiContainer="false" :layoutModelDetails="layoutModelDetails">
        <template #srfmajortext>
        <app-panel-field name="srfmajortext" :data="layoutData" :value="layoutData.srfmajortext"> <app-preset-text-input name="srfmajortext" :layoutModelDetails="layoutModelDetails" :value="layoutData.srfmajortext" @valueChange="handleValueChange"/> </app-panel-field>
        </template>
        <template #author>
        <app-panel-field name="author" :data="layoutData" :value="layoutData.author"> <app-preset-text-input name="author" :layoutModelDetails="layoutModelDetails" :value="layoutData.author" @valueChange="handleValueChange"/> </app-panel-field>
        </template>
        <template #srfdescription>
        <app-panel-field name="srfdescription" :data="layoutData" :value="layoutData.srfdescription"> <app-preset-text-input name="srfdescription" :layoutModelDetails="layoutModelDetails" :value="layoutData.srfdescription" @valueChange="handleValueChange"/> </app-panel-field>
        </template>
    </app-standard-container>
        </template>
    </div>

</template>
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZBOOKEntityService from '@/service/ibizbook/ibizbook-service';
import HasPanelKanBanService from './has-panel-kan-ban-panel-service';
import IBIZBOOKUIService from '@/uiservice/ibizbook/ibizbook-ui-service';
import { PanelDetailModel,PanelRawitemModel,PanelTabPanelModel,PanelTabPageModel,PanelFieldModel,PanelContainerModel,PanelControlModel,PanelUserControlModel,PanelButtonModel } from '@/model/panel-detail';
import HasPanelKanBanModel from './has-panel-kan-ban-panel-model';
import CodeListService from "@/codelist/codelist-service";
import UIService from '@/uiservice/ui-service';


@Component({
    components: {
      
    }
})
export default class HasPanelKanBanBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof HasPanelKanBanBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof HasPanelKanBanBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof HasPanelKanBanBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof HasPanelKanBanBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图操作参数
     *
     * @type {*}
     * @memberof HasPanelKanBanBase
     */
    @Prop() public viewCtx!: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof HasPanelKanBanBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof HasPanelKanBanBase
     */
    public getControlType(): string {
        return 'PANEL'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof HasPanelKanBanBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {HasPanelKanBanService}
     * @memberof HasPanelKanBanBase
     */
    public service: HasPanelKanBanService = new HasPanelKanBanService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZBOOKService}
     * @memberof HasPanelKanBanBase
     */
    public appEntityService: IBIZBOOKEntityService = new IBIZBOOKEntityService({ $store: this.$store });
    


    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  HasPanelKanBanBase
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof HasPanelKanBanBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof HasPanelKanBanBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }


    /**
     * 接口实现
     *
     * @returns {any[]}
     * @memberof HasPanelKanBanBase
     */
    getDatas(): any[] {
        if (!this.layoutData) {
            return [];
        }
        return [this.layoutData];
    }

    /**
     * 接口实现
     *
     * @returns {*}
     * @memberof HasPanelKanBanBase
     */
    getData() {
        return this.layoutData;
    }

    /**
     * 父级部件引用
     *
     * @type {*}
     * @memberof HasPanelKanBanBase
     */
    @Prop() public parentRef?: any;

    /**
     * 面板数据对象
     *
     * @type {*}
     * @memberof HasPanelKanBanBase
     */
    @Prop() public inputData?: any;

    /**
     * 操作栏模型数据
     *
     * @type {*}
     * @memberof HasPanelKanBanBase
     */
    @Prop() public actionModel?: any;

    /**
     * UI数据对象
     *
     * @type {*}
     * @memberof HasPanelKanBanBase
     */
    public data:any = {};

    /**
     * 数据模型对象
     *
     * @type {HasPanelKanBanModel}
     * @memberof HasPanelKanBanBase
     */
    public dataModel:HasPanelKanBanModel = new HasPanelKanBanModel();

    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof HasPanelKanBanBase
     */
    public codeListService:CodeListService = new CodeListService();

    /**
     * 界面UI服务对象
     *
     * @type {IBIZBOOKUIService}
     * @memberof HasPanelKanBanBase
     */  
    public appUIService:IBIZBOOKUIService = new IBIZBOOKUIService();

    /**
     * 视图布局是否加载
     *
     * @public
     * @memberof ItemlayoutpanelBase
     */
    public isLayoutLoadding: boolean = false;

    /**
     * 视图布局数据
     *
     * @public
     * @memberof ItemlayoutpanelBase
     */
    public layoutData:any = {};

    /**
     * 视图布局面板模型对象
     *
     * @public
     * @memberof ItemlayoutpanelBase
     */
    public layoutModelDetails:any = {};

    /**
     * 视图布局顶级成员名称
     *
     * @public
     * @memberof ItemlayoutpanelBase
     */
    public rootLayoutDetailNames: string[] = [ 'container1' ];

    /**
     *  初始化布局
     *
     *  @public
     *  @memberof ItemlayoutpanelBase
     */
    public async initLayout() {
        if (this.rootLayoutDetailNames.length > 0) {
            for (let i = 0; i < this.rootLayoutDetailNames.length; i++) {
                const name = this.rootLayoutDetailNames[i];
                const rootItem = this.layoutItems[name];
                if (!rootItem) {
                    return;
                }
                await this.initLayoutItem(rootItem);
            }
        }
        return true;
    }

    /**
     *  初始化布局项
     *
     *  @public
     *  @memberof ItemlayoutpanelBase
     */
    public async initLayoutItem(layoutModelItem: any, index: number = 0) {
        const { name } = layoutModelItem;
        const layoutModelDetail = Util.getLayoutItemInstance(layoutModelItem);
        if (!index) {
            await layoutModelDetail.load(this.context, this.viewparams);
            this.$set(this.layoutModelDetails, name, layoutModelDetail);
            this.$set(this.layoutData, name, layoutModelDetail.getData());
        } else {
            layoutModelDetail.setIndex(index);
            await layoutModelDetail.load(this.context, this.viewparams);
            this.$set(this.layoutModelDetails, `${name}_${index}`, layoutModelDetail);
            this.$set(this.layoutData, `${name}_${index}`, layoutModelDetail.getData());
        }
        if (layoutModelDetail && layoutModelDetail.details) {
            if (layoutModelDetail.dataRegionType === 'MULTIDATA') {
                const multiData = layoutModelDetail.getData();
                if (multiData && multiData.length > 0) {
                    for (let i = 0; i < multiData.length; i++) {
                        for (let j = 0; j < layoutModelDetail.details.length; j++) {
                            const key = layoutModelDetail.details[j];
                            if (this.layoutItems[key]) {
                                await this.initLayoutItem(this.layoutItems[key], i);
                            }
                        }
                    }
                }
            } else {
                for (let i = 0; i < layoutModelDetail.details.length; i++) {
                    const key = layoutModelDetail.details[i];
                    if (this.layoutItems[key]) {
                        await this.initLayoutItem(this.layoutItems[key],index);
                    }
                }
            }
        }
    }

    /**
     * 视图布局面板项模型对象
     *
     * @public
     * @memberof ItemlayoutpanelBase
     */
    public layoutItems:any = {
        srfmajortext:{ name: 'srfmajortext', type: 'VIEWLAYOUT', caption: '', isShowCaption: false, sysCss: 'kanban-title', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , fieldState: '0', predefinedType: '', renderMode: '', dataItemName:'srfmajortext', wrapMode:'', vAlign:'', hAlign:'', },
        author:{ name: 'author', type: 'VIEWLAYOUT', caption: '', isShowCaption: false, sysCss: 'kanban-author', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , fieldState: '0', predefinedType: '', renderMode: '', dataItemName:'author', wrapMode:'', vAlign:'', hAlign:'', },
        srfdescription:{ name: 'srfdescription', type: 'VIEWLAYOUT', caption: '', isShowCaption: false, sysCss: 'kanban-description', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , fieldState: '0', predefinedType: '', renderMode: '', dataItemName:'srfdescription', wrapMode:'', vAlign:'', hAlign:'', },
        container1:{ name: 'container1', type: 'VIEWLAYOUT', caption: '', titleBarCloseMode: 0, isShowCaption: false, sysCss: 'kanban-panel', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'TABLE_24COL', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:400, widthMode:'PX', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, panel: this , details:['srfmajortext','author','srfdescription'] , dataRegionType: 'INHERIT' }
    };

    /**
     * 值规则对象
     *
     * @type {*}
     * @memberof HasPanelKanBanBase
     */
    public rules:any={
        srfmajortext:[
            { required: false, type: 'string', message: ' 值不能为空'},
            { required: false, type: 'string', message: ' 值不能为空'}
        ],
        author:[
            { required: false, type: 'string', message: ' 值不能为空'},
            { required: false, type: 'string', message: ' 值不能为空'}
        ],
        srfdescription:[
            { required: false, type: 'string', message: ' 值不能为空'},
            { required: false, type: 'string', message: ' 值不能为空'}
        ],
    };

    /**
     * 监听数据对象
     *
     * @memberof HasPanelKanBanBase
     */
    @Watch('inputData',{immediate:true,deep: true})
    public onInputDataChange(newVal: any, oldVal: any){
        if(newVal){
            this.computedUIData(newVal);
            this.layoutData = Util.deepCopy(newVal);
            this.computeButtonState(newVal);
            this.panelLogic('');
            this.$forceUpdate();
        }
    }

    /**
     * 生命周期
     *
     * @memberof HasPanelKanBanBase
     */
    public mounted () {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     *
     * @memberof HasPanelKanBanBase
     */
    public afterMounted () {
        const _this: any = this;
        _this.initLayout().then((result: any) => {
            _this.isLayoutLoadding = false;

        });
    }

    /**
     * 计算UI展示数据
     * 
     * @param codelistArray 代码表模型数组
     * @memberof HasPanelKanBanBase
     */
    public computedUIData(newVal:any){
        if((this.dataModel.getDataItems instanceof Function) && this.dataModel.getDataItems().length >0){
            this.dataModel.getDataItems().forEach((item:any) =>{
                this.data[item.name] = newVal[item.prop];
            })
        }
    }

    /**
     * 计算面板按钮权限状态
     *
     * @param {*} [data] 传入数据
     * @memberof HasPanelKanBanBase
     */
    public computeButtonState(data:any){
        // 若为项布局面板，存在parentRef
        if(this.parentRef){
            let targetData:any = this.parentRef.transformData(data);
            if(this.layoutModelDetails && Object.keys(this.layoutModelDetails).length >0){
                Object.keys(this.layoutModelDetails).forEach((name:any) =>{
                    if(this.layoutModelDetails[name] && this.layoutModelDetails[name].uiAction && this.layoutModelDetails[name].uiAction.dataAccaction && Object.is(this.layoutModelDetails[name].itemType,"BUTTON")){
                        let tempUIAction:any = JSON.parse(JSON.stringify(this.layoutModelDetails[name].uiAction));
                        let result: any[] = ViewTool.calcActionItemAuthState(targetData, [tempUIAction], this.appUIService ? this.appUIService : null);
                        this.layoutModelDetails[name].visible = tempUIAction.visabled;
                        this.layoutModelDetails[name].disabled = tempUIAction.disabled;
                    }
                })
            }
        }
    }

    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof HasPanelKanBanBase
     */
    public opendata(args: any[],fullargs?:any[],params?: any, $event?: any, xData?: any){
        if (this.parentRef.opendata && this.parentRef.opendata instanceof Function) {
            this.parentRef.opendata(args,fullargs,params, $event, xData);
        }
    }

    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof HasPanelKanBanBase
     */
    public newdata(args: any[],fullargs?:any[], params?: any, $event?: any, xData?: any) {
        if (this.parentRef.newdata && this.parentRef.newdata instanceof Function) {
            this.parentRef.newdata(args,fullargs,params, $event, xData);
        }
    }
    
    /**
     * 删除
     *
     * @param {any[]} datas
     * @returns {Promise<any>}
     * @memberof HasPanelKanBanBase
     */
    public async remove(datas: any[]): Promise<any> {
        if (this.parentRef.remove && this.parentRef.remove instanceof Function) {
            return this.parentRef.remove(datas);
        }
    }

    /**
     * 刷新
     *
     * @param {*} [args={}]
     * @memberof HasPanelKanBanBase
     */
    public refresh(args: any = {}) {
        if (this.parentRef.refresh && this.parentRef.refresh instanceof Function) {
            this.parentRef.refresh(args);
        }
    }

    /**
     * 处理值改变
     *
     * @public
     * @memberof ItemlayoutpanelBase
     */
    public handleValueChange(args: { name: string, value: any }) {
        if (!args || !args.name || Object.is(args.name, '') || !this.layoutData.hasOwnProperty(args.name)) {
            return;
        }
        const { name, value } = args;
        this.data[name] = value;
        this.layoutData[name] = value;
        this.layoutModelDetails[name].setData(value);
        this.panelLogic(name);
        this.panelEditItemChange(this.data, name, value);
    }

    /**
     * 面板编辑项值变化后续操作
     *
     * @public
     * @param data 面板数据
     * @param property 编辑项名
     * @param value 编辑项值
     * @returns {void}
     * @memberof HasPanelKanBanBase
     */
    public panelEditItemChange(data: any, property: string, value: any){
        // 面板数据变化事件
        if((this.dataModel.getDataItems instanceof Function) && this.dataModel.getDataItems().length >0){
            let modelitem =this.dataModel.getDataItems().find((item:any) =>{
                return item.name === property;
            }) 
            if(modelitem){
                this.$emit('panelDataChange',{[modelitem.prop]: value});
            }
        }
    }

    /**
     * 面板逻辑
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof HasPanelKanBanBase
     */
    public panelLogic(name: string): void {
                




    }

    /**
     * 获取按钮行为xData
     *
     * @public
     * @memberof ItemlayoutpanelBase
     */
    public getButtonXData(name: string): any {
        let xData = null;
        let curLayoutModel = null;
        Object.values(this.layoutModelDetails).forEach((layoutModel: any) => {
            if (layoutModel.name == name) {
                curLayoutModel = layoutModel;
            }
        })
        // 获取数据容器
        if (curLayoutModel) {
            const getDataArea = (cLayoutModel: any): any => {
                let dataArea = null;
                let parentLayoutModel = null;
                Object.values(this.layoutModelDetails).forEach((pLayoutModel: any) => {
                    if (pLayoutModel.name == cLayoutModel.parentName) {
                        parentLayoutModel = pLayoutModel;
                        if (parentLayoutModel.dataRegionType == 'SINGLEDATA' || parentLayoutModel.dataRegionType == 'MULTIDATA') {
                            dataArea = parentLayoutModel;
                        }
                    }
                })
                if (!dataArea && parentLayoutModel) {
                    dataArea = getDataArea(parentLayoutModel);
                }
                return dataArea;
            }
            xData = getDataArea(curLayoutModel);
        }
        // 获取当前视图
        if (!xData) {
            xData = this;
        }
        return xData;
    }

    /**
     * 处理按钮点击
     *
     * @public
     * @memberof ItemlayoutpanelBase
     */
    public handleButtonClick(name: string, $event?: any) {
        const datas: any[] = [this.layoutData];
        const xData: any = this.getButtonXData(name);
        const paramJO: any = {};
        const contextJO: any = {};
        const _this: any = this;
    }


}
</script>

<style lang='less'>
@import './has-panel-kan-ban-panel.less';
</style>

